/*
 * Copyright 2015-2018 Andres Almiray
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.kordamp.ikonli.dashicons;

import org.kordamp.ikonli.Ikon;

/**
 * @author Andres Almiray
 */
public enum Dashicons implements Ikon {
    ADMIN_APPEARANCE("dashicons-admin-appearance", '\uf100'),
    ADMIN_COLLAPSE("dashicons-admin-collapse", '\uf148'),
    ADMIN_COMMENTS("dashicons-admin-comments", '\uf101'),
    ADMIN_CUSTOMIZER("dashicons-admin-customizer", '\uf540'),
    ADMIN_GENERIC("dashicons-admin-generic", '\uf111'),
    ADMIN_HOME("dashicons-admin-home", '\uf102'),
    ADMIN_LINKS("dashicons-admin-links", '\uf103'),
    ADMIN_MEDIA("dashicons-admin-media", '\uf104'),
    ADMIN_MULTISITE("dashicons-admin-multisite", '\uf541'),
    ADMIN_NETWORK("dashicons-admin-network", '\uf112'),
    ADMIN_PAGE("dashicons-admin-page", '\uf105'),
    ADMIN_PLUGINS("dashicons-admin-plugins", '\uf106'),
    ADMIN_POST("dashicons-admin-post", '\uf109'),
    ADMIN_SETTINGS("dashicons-admin-settings", '\uf108'),
    ADMIN_SITE("dashicons-admin-site", '\uf319'),
    ADMIN_SITE_ALT("dashicons-admin-site-alt", '\uf11d'),
    ADMIN_SITE_ALT2("dashicons-admin-site-alt2", '\uf11e'),
    ADMIN_SITE_ALT3("dashicons-admin-site-alt3", '\uf11f'),
    ADMIN_TOOLS("dashicons-admin-tools", '\uf107'),
    ADMIN_USERS("dashicons-admin-users", '\uf110'),
    ALBUM("dashicons-album", '\uf514'),
    ALIGN_CENTER("dashicons-align-center", '\uf134'),
    ALIGN_LEFT("dashicons-align-left", '\uf135'),
    ALIGN_NONE("dashicons-align-none", '\uf138'),
    ALIGN_RIGHT("dashicons-align-right", '\uf136'),
    ANALYTICS("dashicons-analytics", '\uf183'),
    ARCHIVE("dashicons-archive", '\uf480'),
    ARROW_DOWN("dashicons-arrow-down", '\uf140'),
    ARROW_DOWN_ALT("dashicons-arrow-down-alt", '\uf346'),
    ARROW_DOWN_ALT2("dashicons-arrow-down-alt2", '\uf347'),
    ARROW_LEFT("dashicons-arrow-left", '\uf141'),
    ARROW_LEFT_ALT("dashicons-arrow-left-alt", '\uf340'),
    ARROW_LEFT_ALT2("dashicons-arrow-left-alt2", '\uf341'),
    ARROW_RIGHT("dashicons-arrow-right", '\uf139'),
    ARROW_RIGHT_ALT("dashicons-arrow-right-alt", '\uf344'),
    ARROW_RIGHT_ALT2("dashicons-arrow-right-alt2", '\uf345'),
    ARROW_UP("dashicons-arrow-up", '\uf142'),
    ARROW_UP_ALT("dashicons-arrow-up-alt", '\uf342'),
    ARROW_UP_ALT2("dashicons-arrow-up-alt2", '\uf343'),
    ART("dashicons-art", '\uf309'),
    AWARDS("dashicons-awards", '\uf313'),
    BACKUP("dashicons-backup", '\uf321'),
    BOOK("dashicons-book", '\uf330'),
    BOOK_ALT("dashicons-book-alt", '\uf331'),
    BUDDICONS_ACTIVITY("dashicons-buddicons-activity", '\uf452'),
    BUDDICONS_BBPRESS_LOGO("dashicons-buddicons-bbpress-logo", '\uf12b'),
    BUDDICONS_BUDDYPRESS_LOGO("dashicons-buddicons-buddypress-logo", '\uf448'),
    BUDDICONS_COMMUNITY("dashicons-buddicons-community", '\uf453'),
    BUDDICONS_FORUMS("dashicons-buddicons-forums", '\uf449'),
    BUDDICONS_FRIENDS("dashicons-buddicons-friends", '\uf454'),
    BUDDICONS_GROUPS("dashicons-buddicons-groups", '\uf456'),
    BUDDICONS_PM("dashicons-buddicons-pm", '\uf457'),
    BUDDICONS_REPLIES("dashicons-buddicons-replies", '\uf451'),
    BUDDICONS_TOPICS("dashicons-buddicons-topics", '\uf450'),
    BUDDICONS_TRACKING("dashicons-buddicons-tracking", '\uf455'),
    BUILDING("dashicons-building", '\uf512'),
    BUSINESSMAN("dashicons-businessman", '\uf338'),
    CALENDAR("dashicons-calendar", '\uf145'),
    CALENDAR_ALT("dashicons-calendar-alt", '\uf508'),
    CAMERA("dashicons-camera", '\uf306'),
    CARROT("dashicons-carrot", '\uf511'),
    CART("dashicons-cart", '\uf174'),
    CATEGORY("dashicons-category", '\uf318'),
    CHART_AREA("dashicons-chart-area", '\uf239'),
    CHART_BAR("dashicons-chart-bar", '\uf185'),
    CHART_LINE("dashicons-chart-line", '\uf238'),
    CHART_PIE("dashicons-chart-pie", '\uf184'),
    CLIPBOARD("dashicons-clipboard", '\uf481'),
    CLOCK("dashicons-clock", '\uf469'),
    CLOUD("dashicons-cloud", '\uf176'),
    CONTROLS_BACK("dashicons-controls-back", '\uf518'),
    CONTROLS_FORWARD("dashicons-controls-forward", '\uf519'),
    CONTROLS_PAUSE("dashicons-controls-pause", '\uf523'),
    CONTROLS_PLAY("dashicons-controls-play", '\uf522'),
    CONTROLS_REPEAT("dashicons-controls-repeat", '\uf515'),
    CONTROLS_SKIPBACK("dashicons-controls-skipback", '\uf516'),
    CONTROLS_SKIPFORWARD("dashicons-controls-skipforward", '\uf517'),
    CONTROLS_VOLUMEOFF("dashicons-controls-volumeoff", '\uf520'),
    CONTROLS_VOLUMEON("dashicons-controls-volumeon", '\uf521'),
    DASHBOARD("dashicons-dashboard", '\uf226'),
    DESKTOP("dashicons-desktop", '\uf472'),
    DISMISS("dashicons-dismiss", '\uf153'),
    DOWNLOAD("dashicons-download", '\uf316'),
    EDIT("dashicons-edit", '\uf464'),
    EDITOR_ALIGNCENTER("dashicons-editor-aligncenter", '\uf207'),
    EDITOR_ALIGNLEFT("dashicons-editor-alignleft", '\uf206'),
    EDITOR_ALIGNRIGHT("dashicons-editor-alignright", '\uf208'),
    EDITOR_BOLD("dashicons-editor-bold", '\uf200'),
    EDITOR_BREAK("dashicons-editor-break", '\uf474'),
    EDITOR_CODE("dashicons-editor-code", '\uf475'),
    EDITOR_CONTRACT("dashicons-editor-contract", '\uf506'),
    EDITOR_CUSTOMCHAR("dashicons-editor-customchar", '\uf220'),
    EDITOR_EXPAND("dashicons-editor-expand", '\uf211'),
    EDITOR_HELP("dashicons-editor-help", '\uf223'),
    EDITOR_INDENT("dashicons-editor-indent", '\uf222'),
    EDITOR_INSERTMORE("dashicons-editor-insertmore", '\uf209'),
    EDITOR_ITALIC("dashicons-editor-italic", '\uf201'),
    EDITOR_JUSTIFY("dashicons-editor-justify", '\uf214'),
    EDITOR_KITCHENSINK("dashicons-editor-kitchensink", '\uf212'),
    EDITOR_LTR("dashicons-editor-ltr", '\uf129'),
    EDITOR_OL("dashicons-editor-ol", '\uf204'),
    EDITOR_OUTDENT("dashicons-editor-outdent", '\uf221'),
    EDITOR_PARAGRAPH("dashicons-editor-paragraph", '\uf476'),
    EDITOR_PASTE_TEXT("dashicons-editor-paste-text", '\uf217'),
    EDITOR_PASTE_WORD("dashicons-editor-paste-word", '\uf216'),
    EDITOR_QUOTE("dashicons-editor-quote", '\uf205'),
    EDITOR_REMOVEFORMATTING("dashicons-editor-removeformatting", '\uf218'),
    EDITOR_RTL("dashicons-editor-rtl", '\uf320'),
    EDITOR_SPELLCHECK("dashicons-editor-spellcheck", '\uf210'),
    EDITOR_STRIKETHROUGH("dashicons-editor-strikethrough", '\uf224'),
    EDITOR_TABLE("dashicons-editor-table", '\uf535'),
    EDITOR_TEXTCOLOR("dashicons-editor-textcolor", '\uf215'),
    EDITOR_UL("dashicons-editor-ul", '\uf203'),
    EDITOR_UNDERLINE("dashicons-editor-underline", '\uf213'),
    EDITOR_UNLINK("dashicons-editor-unlink", '\uf225'),
    EDITOR_VIDEO("dashicons-editor-video", '\uf219'),
    EMAIL("dashicons-email", '\uf465'),
    EMAIL_ALT("dashicons-email-alt", '\uf466'),
    EMAIL_ALT2("dashicons-email-alt2", '\uf10a'),
    EXCERPT_VIEW("dashicons-excerpt-view", '\uf164'),
    EXTERNAL("dashicons-external", '\uf504'),
    FACEBOOK("dashicons-facebook", '\uf304'),
    FACEBOOK_ALT("dashicons-facebook-alt", '\uf305'),
    FEEDBACK("dashicons-feedback", '\uf175'),
    FILTER("dashicons-filter", '\uf536'),
    FLAG("dashicons-flag", '\uf227'),
    FORMAT_ASIDE("dashicons-format-aside", '\uf123'),
    FORMAT_AUDIO("dashicons-format-audio", '\uf127'),
    FORMAT_CHAT("dashicons-format-chat", '\uf125'),
    FORMAT_GALLERY("dashicons-format-gallery", '\uf161'),
    FORMAT_IMAGE("dashicons-format-image", '\uf128'),
    FORMAT_LINKS("dashicons-format-links", '\uf103'),
    FORMAT_QUOTE("dashicons-format-quote", '\uf122'),
    FORMAT_STANDARD("dashicons-format-standard", '\uf109'),
    FORMAT_STATUS("dashicons-format-status", '\uf130'),
    FORMAT_VIDEO("dashicons-format-video", '\uf126'),
    FORMS("dashicons-forms", '\uf314'),
    GOOGLEPLUS("dashicons-googleplus", '\uf462'),
    GRID_VIEW("dashicons-grid-view", '\uf509'),
    GROUPS("dashicons-groups", '\uf307'),
    HAMMER("dashicons-hammer", '\uf308'),
    HEART("dashicons-heart", '\uf487'),
    HIDDEN("dashicons-hidden", '\uf530'),
    ID("dashicons-id", '\uf336'),
    ID_ALT("dashicons-id-alt", '\uf337'),
    IMAGES_ALT("dashicons-images-alt", '\uf232'),
    IMAGES_ALT2("dashicons-images-alt2", '\uf233'),
    IMAGE_CROP("dashicons-image-crop", '\uf165'),
    IMAGE_FILTER("dashicons-image-filter", '\uf533'),
    IMAGE_FLIP_HORIZONTAL("dashicons-image-flip-horizontal", '\uf169'),
    IMAGE_FLIP_VERTICAL("dashicons-image-flip-vertical", '\uf168'),
    IMAGE_ROTATE("dashicons-image-rotate", '\uf531'),
    IMAGE_ROTATE_LEFT("dashicons-image-rotate-left", '\uf166'),
    IMAGE_ROTATE_RIGHT("dashicons-image-rotate-right", '\uf167'),
    INDEX_CARD("dashicons-index-card", '\uf510'),
    INFO("dashicons-info", '\uf348'),
    LAPTOP("dashicons-laptop", '\uf547'),
    LAYOUT("dashicons-layout", '\uf538'),
    LEFTRIGHT("dashicons-leftright", '\uf229'),
    LIGHTBULB("dashicons-lightbulb", '\uf339'),
    LIST_VIEW("dashicons-list-view", '\uf163'),
    LOCATION("dashicons-location", '\uf230'),
    LOCATION_ALT("dashicons-location-alt", '\uf231'),
    LOCK("dashicons-lock", '\uf160'),
    MARKER("dashicons-marker", '\uf159'),
    MEDIA_ARCHIVE("dashicons-media-archive", '\uf501'),
    MEDIA_AUDIO("dashicons-media-audio", '\uf500'),
    MEDIA_CODE("dashicons-media-code", '\uf499'),
    MEDIA_DEFAULT("dashicons-media-default", '\uf498'),
    MEDIA_DOCUMENT("dashicons-media-document", '\uf497'),
    MEDIA_INTERACTIVE("dashicons-media-interactive", '\uf496'),
    MEDIA_SPREADSHEET("dashicons-media-spreadsheet", '\uf495'),
    MEDIA_TEXT("dashicons-media-text", '\uf491'),
    MEDIA_VIDEO("dashicons-media-video", '\uf490'),
    MEGAPHONE("dashicons-megaphone", '\uf488'),
    MENU("dashicons-menu", '\uf333'),
    MENU_ALT("dashicons-menu-alt", '\uf10b'),
    MICROPHONE("dashicons-microphone", '\uf482'),
    MIGRATE("dashicons-migrate", '\uf310'),
    MINUS("dashicons-minus", '\uf460'),
    MONEY("dashicons-money", '\uf526'),
    MOVE("dashicons-move", '\uf545'),
    NAMETAG("dashicons-nametag", '\uf484'),
    NETWORKING("dashicons-networking", '\uf325'),
    NO("dashicons-no", '\uf158'),
    NO_ALT("dashicons-no-alt", '\uf335'),
    PALMTREE("dashicons-palmtree", '\uf527'),
    PAPERCLIP("dashicons-paperclip", '\uf546'),
    PERFORMANCE("dashicons-performance", '\uf311'),
    PHONE("dashicons-phone", '\uf525'),
    PLAYLIST_AUDIO("dashicons-playlist-audio", '\uf492'),
    PLAYLIST_VIDEO("dashicons-playlist-video", '\uf493'),
    PLUS("dashicons-plus", '\uf132'),
    PLUS_ALT("dashicons-plus-alt", '\uf502'),
    PLUS_LIGHT("dashicons-plus-light", '\uf10c'),
    PORTFOLIO("dashicons-portfolio", '\uf322'),
    POST_STATUS("dashicons-post-status", '\uf173'),
    PRESSTHIS("dashicons-pressthis", '\uf157'),
    PRODUCTS("dashicons-products", '\uf312'),
    RANDOMIZE("dashicons-randomize", '\uf503'),
    REDO("dashicons-redo", '\uf172'),
    REST_API("dashicons-rest-api", '\uf124'),
    RSS("dashicons-rss", '\uf303'),
    SCHEDULE("dashicons-schedule", '\uf489'),
    SCREENOPTIONS("dashicons-screenoptions", '\uf180'),
    SEARCH("dashicons-search", '\uf179'),
    SHARE("dashicons-share", '\uf237'),
    SHARE_ALT("dashicons-share-alt", '\uf240'),
    SHARE_ALT2("dashicons-share-alt2", '\uf242'),
    SHIELD("dashicons-shield", '\uf332'),
    SHIELD_ALT("dashicons-shield-alt", '\uf334'),
    SLIDES("dashicons-slides", '\uf181'),
    SMARTPHONE("dashicons-smartphone", '\uf470'),
    SMILEY("dashicons-smiley", '\uf328'),
    SORT("dashicons-sort", '\uf156'),
    SOS("dashicons-sos", '\uf468'),
    STAR_EMPTY("dashicons-star-empty", '\uf154'),
    STAR_FILLED("dashicons-star-filled", '\uf155'),
    STAR_HALF("dashicons-star-half", '\uf459'),
    STICKY("dashicons-sticky", '\uf537'),
    STORE("dashicons-store", '\uf513'),
    TABLET("dashicons-tablet", '\uf471'),
    TAG("dashicons-tag", '\uf323'),
    TAGCLOUD("dashicons-tagcloud", '\uf479'),
    TESTIMONIAL("dashicons-testimonial", '\uf473'),
    TEXT("dashicons-text", '\uf478'),
    THUMBS_DOWN("dashicons-thumbs-down", '\uf542'),
    THUMBS_UP("dashicons-thumbs-up", '\uf529'),
    TICKETS("dashicons-tickets", '\uf486'),
    TICKETS_ALT("dashicons-tickets-alt", '\uf524'),
    TRANSLATION("dashicons-translation", '\uf326'),
    TRASH("dashicons-trash", '\uf182'),
    TWITTER("dashicons-twitter", '\uf301'),
    UNDO("dashicons-undo", '\uf171'),
    UNIVERSAL_ACCESS("dashicons-universal-access", '\uf483'),
    UNIVERSAL_ACCESS_ALT("dashicons-universal-access-alt", '\uf507'),
    UNLOCK("dashicons-unlock", '\uf528'),
    UPDATE("dashicons-update", '\uf463'),
    UPLOAD("dashicons-upload", '\uf317'),
    VAULT("dashicons-vault", '\uf178'),
    VIDEO_ALT("dashicons-video-alt", '\uf234'),
    VIDEO_ALT2("dashicons-video-alt2", '\uf235'),
    VIDEO_ALT3("dashicons-video-alt3", '\uf236'),
    VISIBILITY("dashicons-visibility", '\uf177'),
    WARNING("dashicons-warning", '\uf534'),
    WELCOME_ADD_PAGE("dashicons-welcome-add-page", '\uf133'),
    WELCOME_COMMENTS("dashicons-welcome-comments", '\uf117'),
    WELCOME_EDIT_PAGE("dashicons-welcome-edit-page", '\uf119'),
    WELCOME_LEARN_MORE("dashicons-welcome-learn-more", '\uf118'),
    WELCOME_VIEW_SITE("dashicons-welcome-view-site", '\uf115'),
    WELCOME_WIDGETS_MENUS("dashicons-welcome-widgets-menus", '\uf116'),
    WELCOME_WRITE_BLOG("dashicons-welcome-write-blog", '\uf119'),
    WORDPRESS("dashicons-wordpress", '\uf120'),
    WORDPRESS_ALT("dashicons-wordpress-alt", '\uf324'),
    YES("dashicons-yes", '\uf147'),
    YES_ALT("dashicons-yes-alt", '\uf12a');

    public static Dashicons findByDescription(String description) {
        for (Dashicons font : values()) {
            if (font.getDescription().equals(description)) {
                return font;
            }
        }
        throw new IllegalArgumentException("Icon description '" + description + "' is invalid!");
    }

    private String description;
    private char code;

    Dashicons(String description, char code) {
        this.description = description;
        this.code = code;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public char getCode() {
        return code;
    }
}